﻿Public Class frmDomino

    Private Base As String = "https://internetorder.dominos.com.au/accessible/select-pickup"

    Private Enum Status
        Begin
        DataEntered
        StoreSelected
        PickupConfirmed
        TimeConfirmed
        CodeEntered
        RemoveEntered
        Abort
    End Enum

    Private Code As String = "123456"
    Private Content As String = ""
    Private Current As Status = Status.Begin
    Private Line As Integer

    Private CommandLineMode As Boolean
    Private CommandLineStringTypes As String() = New String() {"name", "phone", "store", "mail", "from", "to"}
    Private CommandLineStringTypesShort As String() = New String() {"n", "p", "s", "m", "f", "t"}
    Private CommandLineStringContent As String() = New String() {"", "", "", "", "", ""}

    Private Sub frmDomino_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        CommandLineStringContent(0) = My.Settings.Name
        CommandLineStringContent(1) = My.Settings.Phone
        CommandLineStringContent(2) = My.Settings.Store
        CommandLineStringContent(3) = My.Settings.Mail
        CommandLineStringContent(4) = My.Settings.Min
        CommandLineStringContent(5) = My.Settings.Max

        Dim length As Integer = System.Environment.GetCommandLineArgs().Length
        If length > 1 Then
            Dim lastCommandId As Integer = -1
            For I As Integer = 1 To length - 1
                Dim Command As String = System.Environment.GetCommandLineArgs()(I)
                If Command.StartsWith("-") Then
                    If Command = "-i" Or Command = "-invisible" Then
                        CommandLineMode = True
                        Me.WindowState = FormWindowState.Minimized
                    ElseIf Command.Length = 2 Then
                        lastCommandId = Array.IndexOf(CommandLineStringTypesShort, Command.Substring(1))
                    Else
                        lastCommandId = Array.IndexOf(CommandLineStringTypes, Command.Substring(1))
                    End If
                ElseIf Not lastCommandId = -1 Then
                    If Not Command = "" Then
                        CommandLineStringContent.SetValue(Command, lastCommandId)
                        lastCommandId = -1
                    End If
                End If
            Next

            Try
                txtName.Text = CommandLineStringContent(0)
                txtPhone.Text = CommandLineStringContent(1)
                txtStore.Text = CommandLineStringContent(2)
                txtMail.Text = CommandLineStringContent(3)
                nudMin.Value = CommandLineStringContent(4)
                nudMax.Value = CommandLineStringContent(5)
            Catch ex As Exception
            End Try

            btnFill_Click(Nothing, Nothing)
            btnTry_Click(Nothing, Nothing)
        End If

    End Sub

    Private Structure CommandLineArgs
        Dim name As String
        Dim phone As String
        Dim store As String
        Dim mail As String
        Dim from As String
        Dim till As String

        'Dim hide As Boolean
    End Structure

    Private Sub EnterData()
        'EnterData("Name", "0123456789", "Dev", "test@test.com")
        EnterData(txtName.Text, txtPhone.Text, txtStore.Text, txtMail.Text)
    End Sub
    Private Sub EnterData(ByVal Name As String, ByVal Phone As String, ByVal Store As String, ByVal Mail As String)
        With web.Document.Forms("form1").All
            .Item("txtCustomerName").InnerText = Name
            .Item("txtPhoneNumber").InnerText = Phone
            .Item("txtPickupStore").InnerText = Store
            .Item("txtEmail").InnerText = Mail
            Current = Status.DataEntered
            .Item("cmdSubmit").InvokeMember("Click")
        End With
    End Sub
    Private Sub SelectStore()
        Current = Status.StoreSelected
        web.Document.Forms("form1").All.Item("ContentPlaceHolder1_ctl13_rptStores_cmdSelectStore_0").InvokeMember("Click")
    End Sub
    Private Sub ConfirmPickup()
        Current = Status.PickupConfirmed
        web.Document.Forms("form1").All.Item("cmdSubmit").InvokeMember("Click")
    End Sub
    Private Sub ConfirmTime()
        Current = Status.TimeConfirmed
        web.Document.Forms("form1").All.Item("cmdSubmit").InvokeMember("Click")
    End Sub
    Private Sub EnterCode()
        If Line < txtCodes.Lines.Length Then
            Content = ""
            Code = txtCodes.Lines(Line)

            txtCodes.SelectionStart = FindLine(txtCodes.Lines, Line)
            txtCodes.SelectionLength = Code.Length
            txtCodes.ScrollToCaret()

            Line += 1
            If Not Code = "" Then
                With web.Document.Forms("form1").All
                    .Item("txtVoucher").InnerText = Code
                    Current = Status.CodeEntered
                    .Item("cmdAdd").InvokeMember("Click")
                End With
            Else
                EnterCode()
            End If
        Else
            btnTry_Click(Nothing, Nothing)
            If CommandLineMode Then
                If txtValid.TextLength > 0 Then
                    Me.Show()
                Else
                    My.Settings.Reload()
                    If CommandLineMode Then
                        Me.Close()
                        Application.Exit()
                    End If
                End If
            End If
        End If
    End Sub
    Private Function FindLine(ByVal Lines As String(), ByVal LineBegin As Integer)
        Dim count As Integer
        For i As Integer = 0 To LineBegin
            count += Lines(i).Length + vbNewLine.Length
        Next
        Return count
    End Function

    Private Sub GetStatus()
        For Each element As HtmlElement In web.Document.All.Item("menuMessages").All
            If (element.TagName = "DIV") Then
                For Each subElement As HtmlElement In element.GetElementsByTagName("li")
                    If element.InnerText.Contains("Not Valid") Then

                    Else
                        Content = subElement.InnerText.Replace(vbNewLine, " ")
                    End If
                    RemoveAllChecked()
                    Exit For
                Next
            End If
            Exit For
        Next

    End Sub
    Private Sub RemoveAllChecked()
        Dim count As Integer = 0

        For Each element As HtmlElement In web.Document.GetElementById("orderDetailsBlock").GetElementsByTagName("INPUT")
            If element.TagName = "INPUT" And element.GetAttribute("type") = "checkbox" Then
                'element.SetAttribute("onclick", "javascript: alert('xss');")
                element.InvokeMember("click")
                count += 1
            End If
        Next
        If count > 0 Then
            If Not txtValid.Text.Contains(Code & vbNewLine) Then
                txtValid.Text &= Code + " - " & Content & vbNewLine
            End If
        End If
        If web.Document.All.Item("cmdRemoveItems") IsNot Nothing Then
            Current = Status.RemoveEntered
            With web.Document.All.Item("cmdRemoveItems")
                .SetAttribute("onclick", "")
                .InvokeMember("Click")
            End With
        Else
            EnterCode()
        End If
    End Sub

    Private Sub web_DocumentCompleted(ByVal sender As System.Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs) Handles web.DocumentCompleted
        Select Case Current
            Case Status.Begin
                EnterData()
            Case Status.DataEntered
                SelectStore()
            Case Status.StoreSelected
                ConfirmPickup()
            Case Status.PickupConfirmed
                ConfirmTime()
            Case Status.TimeConfirmed
                EnterCode()
            Case Status.CodeEntered
                GetStatus()
            Case Status.RemoveEntered
                EnterCode()
        End Select
    End Sub

    Private Sub btnTry_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTry.Click
        If btnTry.Text = "Check Codes" Then
            btnTry.Text = "Stop"
            txtValid.Text = ""
            txtCodes.ReadOnly = True
            Line = 0
            If txtCodes.Lines.Length > 0 Then
                If Current = Status.CodeEntered Or Current = Status.RemoveEntered Then
                    EnterCode()
                Else
                    Current = Status.Begin
                    web.Navigate(Base)
                End If
            Else
                btnTry_Click(Nothing, Nothing)
            End If
        Else
            web.Stop()
            txtCodes.ReadOnly = False
            btnTry.Text = "Check Codes"
        End If
    End Sub

    Private Sub btnFill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFill.Click
        If Not txtCodes.ReadOnly Then
            Dim tmpText As String = ""
            txtCodes.Text = ""
            For i As Integer = nudMin.Value To nudMax.Value
                txtCodes.Text &= i.ToString("00000") & vbNewLine
            Next
            Application.DoEvents()
        End If
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        My.Settings.Save()
    End Sub

    Private Sub btnCmd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCmd.Click
        Dim MsgText As String = "You may use the command line: " & vbNewLine & vbNewLine
        For i As Integer = 0 To CommandLineStringTypes.Length - 1
            MsgText &= "-" & CommandLineStringTypes(i) & " " & "-" & CommandLineStringTypesShort(i) & vbNewLine
        Next
        MsgText &= "-invisible" & " " & "-i"
        MsgText &= vbNewLine & vbNewLine & ""
        MsgBox(MsgText, MsgBoxStyle.Information, "Command Line")
    End Sub

    Private Sub tabList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tabList.Click

    End Sub
End Class
